Index: trunk/LMDZ.MARS/util/display_netcdf.py
===================================================================
--- trunk/LMDZ.MARS/util/display_netcdf.py	(revision 3818)
+++ trunk/LMDZ.MARS/util/display_netcdf.py	(revision 3824)
@@ -210,6 +210,4 @@
             linewidth=0.5
         )
-        #gl.top_labels = False
-        #gl.right_labels = False
 
         # Plot data in PlateCarree projection
@@ -229,5 +227,5 @@
         label = varname + (f" ({units})" if units else "")
         cbar.set_label(label)
-        ax.set_title(f"{varname} — {pole.capitalize()} Pole", pad=50)
+        ax.set_title(f"{varname} — {pole.capitalize()} polar region", pad=20, y=1.05, fontsize=12, fontweight='bold')
 
         figs.append(fig)
@@ -362,5 +360,5 @@
 
     # Create plotter
-    plotter = Plotter(title="3D topography view", bg="bb", axes=0)
+    plotter = Plotter(title="3D globe view", bg="bb", axes=0)
 
     # Configure camera
@@ -409,5 +407,5 @@
         plt.xlabel(time_var or "Time Index")
         plt.ylabel(varname + (f" ({var.units})" if hasattr(var, "units") else ""))
-        plt.title(f"{varname} vs {time_var or 'Index'}")
+        plt.title(f"{varname} vs {time_var or 'Index'}", fontweight='bold')
         if output_path:
             plt.savefig(output_path, bbox_inches="tight")
@@ -442,5 +440,5 @@
         cbar = plt.colorbar()
         cbar.set_label(varname + (f" ({var.units})" if hasattr(var, "units") else ""))
-        plt.title(f"{varname} averaged over latitude")
+        plt.title(f"{varname} averaged over latitude", fontweight='bold')
         if output_path:
             plt.savefig(output_path, bbox_inches="tight")
@@ -564,5 +562,5 @@
                     cbar = fig.colorbar(cf, ax=ax, pad=0.02)
                     cbar.set_label(varname + (f" ({var.units})" if hasattr(var, "units") else ""))
-                    ax.set_title(f"{varname} (interpolated map over physical_points)")
+                    ax.set_title(f"{varname} (interpolated map over physical_points)", fontweight='bold')
                     ax.set_xlabel(f"Longitude ({getattr(dataset.variables[lonv], 'units', 'deg')})")
                     ax.set_ylabel(f"Latitude ({getattr(dataset.variables[latv], 'units', 'deg')})")
@@ -600,5 +598,5 @@
                 plt.xlabel(varname + (f" ({var.units})" if hasattr(var, "units") else ""))
                 plt.ylabel(coord + (f" ({dataset.variables[coord].units})" if hasattr(dataset.variables[coord], "units") else ""))
-                plt.title(f"{varname} vs {coord}")
+                plt.title(f"{varname} vs {coord}", fontweight='bold')
                 if output_path:
                     plt.savefig(output_path, bbox_inches="tight")
@@ -612,5 +610,5 @@
         plt.xlabel("Index")
         plt.ylabel(varname + (f" ({var.units})" if hasattr(var, "units") else ""))
-        plt.title(f"{varname} (1D)")
+        plt.title(f"{varname} (1D)", fontweight='bold')
         if output_path:
             plt.savefig(output_path, bbox_inches="tight")
@@ -620,5 +618,5 @@
         return
 
-    # if dslice.ndim == 2:
+    if dslice.ndim == 2:
         lat_idx2 = find_dim_index(dims, LAT_DIMS)
         lon_idx2 = find_dim_index(dims, LON_DIMS)
@@ -630,4 +628,9 @@
             lats = dataset.variables[latv][:]
             lons = dataset.variables[lonv][:]
+
+            # Correct latitudes order
+            if lats[0] > lats[-1]:
+                lats = lats[::-1]
+                dslice = np.flipud(dslice)
 
             # Handle masked arrays
@@ -675,5 +678,5 @@
             cbar.set_label(varname + (f" ({dataset.variables[varname].units})"
                                       if hasattr(dataset.variables[varname], "units") else ""))
-            ax.set_title(f"{varname} (lat × lon)")
+            ax.set_title(f"{varname} (lat × lon)", fontweight='bold')
             ax.set_xlabel(f"Longitude ({getattr(dataset.variables[lonv], 'units', 'deg')})")
             ax.set_ylabel(f"Latitude ({getattr(dataset.variables[latv], 'units', 'deg')})")
@@ -702,5 +705,5 @@
         plt.xlabel("Dim 2 index")
         plt.ylabel("Dim 1 index")
-        plt.title(f"{varname} (2D)")
+        plt.title(f"{varname} (2D)", fontweight='bold')
         if output_path:
             plt.savefig(output_path, bbox_inches="tight")
@@ -891,5 +894,5 @@
         plt.xlabel(time_var or "Time Index")
         plt.ylabel(varname + (f" ({var_obj.units})" if hasattr(var_obj, "units") else ""))
-        plt.title(f"{varname} vs {time_var or 'Index'}")
+        plt.title(f"{varname} vs {time_var or 'Index'}", fontweight='bold')
         if output_path:
             plt.savefig(output_path, bbox_inches="tight")